/*
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
#include <stdlib.h>
#include <gtk/gtk.h>
#include "callback.h"
#include "def.h"

/* interface_create: take cares of building the interface.
 * Please keep this function at the end of this file.
 */
GtkWidget ** interface_create(int max, struct _prog *prog_data)
{
	GtkWidget *fenetre;
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *button;
	GtkWidget *aire_de_dessin;
	GtkWidget *spinbutton;
	GtkWidget *icon;
	
	GtkWidget **widgets = NULL;
	
	widgets = (GtkWidget **) malloc(sizeof(GtkWidget *)* max);
	
	if(widgets != NULL)
	{
		fenetre = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title( GTK_WINDOW(fenetre), "Belooted" );
		g_signal_connect( G_OBJECT(fenetre), "destroy", G_CALLBACK(quit), prog_data );
		g_signal_connect( G_OBJECT(fenetre), "check_resize", G_CALLBACK(resize), prog_data );

		vbox = gtk_vbox_new(FALSE, 0);
		gtk_container_add( GTK_CONTAINER(fenetre), vbox);
		
		aire_de_dessin = gtk_drawing_area_new();
		gtk_box_pack_start(GTK_BOX(vbox), aire_de_dessin, TRUE, TRUE, 2);
		
		gtk_widget_set_size_request( aire_de_dessin, 450, 420);
		
		hbox = gtk_hbox_new(FALSE, 0);
		
		gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 2);
		
		button= gtk_button_new_with_label("Start");
		gtk_widget_set_sensitive(button, FALSE);
		
		gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, TRUE, 2);
		
		
		/*spinbutton= gtk_spin_button_new(
			GTK_ADJUSTMENT(gtk_adjustment_new(3,1,4,1,1,1)), 0, 1
		);*/
		spinbutton = gtk_spin_button_new_with_range(1, 4, 1);
		gtk_widget_set_sensitive(spinbutton, FALSE);
		
		gtk_box_pack_start(GTK_BOX(hbox), spinbutton, FALSE, FALSE, 2);
		
		icon = gtk_image_new();
		
		gtk_box_pack_start(GTK_BOX(hbox), icon, FALSE, FALSE, 2);
		
		g_signal_connect( G_OBJECT(button), "clicked", G_CALLBACK(event_start), prog_data);
		
		g_signal_connect( G_OBJECT(aire_de_dessin), "realize", G_CALLBACK(realisation), prog_data );
		g_signal_connect( G_OBJECT(aire_de_dessin), "expose_event", G_CALLBACK(rafraichissement), prog_data );

		gtk_widget_add_events(aire_de_dessin, GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK | GDK_BUTTON_MOTION_MASK );

		g_signal_connect(G_OBJECT(aire_de_dessin), "button_press_event", G_CALLBACK(button_press_event), prog_data);
		g_signal_connect(G_OBJECT(aire_de_dessin), "button_release_event", G_CALLBACK(button_release_event), prog_data);

		g_signal_connect(G_OBJECT(aire_de_dessin), "motion_notify_event", G_CALLBACK(motion_notify_event), prog_data);
		
		if(max >= 6)
		{
			widgets[0] = fenetre;
			widgets[1] = vbox;
			widgets[2] = button;
			widgets[3] = aire_de_dessin;
			widgets[4] = spinbutton;
			widgets[5] = icon;
		}
		
		prog_data->area = aire_de_dessin;
		prog_data->button = button;
	}
	
	return(widgets);	
}
